-- Input parameters
-- dbweb-tables-count - number of tables to create
--
--
--

function create_insert(table_id)

   local index_name
   local i
   local j
   local query

   i = table_id


   print("Creating database sbtest" .. i)
   db_query("CREATE DATABASE IF NOT EXISTS sbtest" .. i)
   db_query("USE sbtest" .. i)

   print("Creating table 'users'")
   	query = [[
CREATE TABLE IF NOT EXISTS `users` (
  `user_id` BIGINT UNSIGNED NOT NULL AUTO_INCREMENT ,
  `username` VARCHAR(45) NOT NULL ,
  `password` VARCHAR(45) NOT NULL ,
  `created` DATETIME NOT NULL ,
  PRIMARY KEY (`user_id`) )
ENGINE = ]] .. mysql_table_engine

   db_query(query)
   db_query("TRUNCATE TABLE users")

   print("Inserting " .. users_table_size .. " records into 'users'")
   
   db_bulk_insert_init("INSERT INTO users (username, password, created) VALUES")

   local c_val
   local pad_val


   for j = 1, users_table_size do

   c_val = sb_rand_str([[
###########-###########]])
   pad_val = sb_rand_str([[
###########-###########]])

    db_bulk_insert_next("('".. c_val .."', '" .. pad_val .. "', DATE_SUB(NOW(), INTERVAL "..sb_rand(1,max_history_min) .. " SECOND) )")
   end

   db_bulk_insert_done()

---
--  Stream TABLE
--

   print("Creating table 'stream'")
   	query = [[
CREATE TABLE IF NOT EXISTS `stream` (
  `stream_id` BIGINT UNSIGNED NOT NULL AUTO_INCREMENT ,
  `user_id` BIGINT UNSIGNED NOT NULL ,
  `shared_circle_id` BIGINT UNSIGNED NOT NULL ,
  `title` VARCHAR(255) NOT NULL ,
  `message` TEXT NOT NULL ,
  `posted` DATETIME NOT NULL ,
  `plusone_count` BIGINT NOT NULL DEFAULT 0 ,
  `comments_count` INT NOT NULL DEFAULT 0 ,
  PRIMARY KEY (`stream_id`) ,
  INDEX `fk_stream_users` (`user_id` ASC) ,
  INDEX `fk_stream_circles1` (`shared_circle_id` ASC) 
) ENGINE = ]] .. mysql_table_engine

   db_query(query)
   db_query("TRUNCATE TABLE stream")

   if dbweb_use_fk then
	query = [[  ALTER TABLE circles_names ADD 
  CONSTRAINT `fk_stream_users` FOREIGN KEY (`user_id` ) REFERENCES `users` (`user_id` ) ]]

	query = [[  ALTER TABLE circles_names ADD 
  CONSTRAINT `fk_stream_circles1` FOREIGN KEY (`shared_circle_id` ) REFERENCES `circles` (`circle_id` ) ]]

    db_query(query)

   end

   print("Inserting " .. users_table_size * stream_scale .. " records into 'stream'")
   
   db_bulk_insert_init("INSERT INTO stream (user_id, shared_circle_id, title, message, posted, plusone_count) VALUES")

   local c_val
   local pad_val


   for j = 1, users_table_size * stream_scale do

   c_val = sb_rand_str([[
@@@@@@@@@@@@@@@@@@@@@@-@ @@@@@@@@@@@@@@]])
   pad_val = sb_rand_str([[
@@@@@@@@@@ @@@@@ @@@@@@@@@@@@@@@@ @@@@@@ @@@@@@@@@@@@@ ########]])

    db_bulk_insert_next(string.format("(%u, %u, '%s','%s',DATE_SUB(NOW(), INTERVAL %u SECOND), %u)", 
	sb_rand(1, users_table_size), (sb_rand_uniform(1,100)<80) and 1 or sb_rand(1, users_table_size*circles_scale), c_val, pad_val, sb_rand(1, max_history_min), sb_rand(1, users_table_size / stream_plusone_factor) ))
   end

   db_bulk_insert_done()

--
-- PlusOne table
-- 


   print("Creating table 'plusone'")
   query = [[
CREATE  TABLE IF NOT EXISTS `plusone` (
  `plusone_id` BIGINT UNSIGNED NOT NULL AUTO_INCREMENT ,
  `user_id` BIGINT UNSIGNED NOT NULL ,
  `stream_id` BIGINT UNSIGNED NOT NULL ,
  `plusone_date` DATETIME NOT NULL ,
  PRIMARY KEY (`plusone_id`) ,
  INDEX `fk_plus_users1` (`user_id` ASC) ,
  INDEX `fk_plus_wall1` (`stream_id` ASC) ,
  UNIQUE INDEX `unq_user_stream` (`user_id` ASC, `stream_id` ASC) 
) ENGINE = ]] .. mysql_table_engine

   db_query(query)
   db_query("TRUNCATE TABLE plusone")

   if dbweb_use_fk then
	query = [[  alter table ilike add 
  CONSTRAINT `fk_plus_users1` FOREIGN KEY (`user_id` ) REFERENCES `users` (`user_id` )  ]]

    db_query(query)

	query = [[  alter table ilike add 
  CONSTRAINT `fk_plus_wall1` FOREIGN KEY (`stream_id` ) REFERENCES `stream` (`stream_id` ) ]]

    db_query(query)

   end

   print("Inserting " .. users_table_size * plusone_scale .. " records into 'plusone'")
   
   db_bulk_insert_init("INSERT IGNORE INTO plusone (user_id, stream_id, plusone_date) VALUES")


   for j = 1, users_table_size * plusone_scale do

    db_bulk_insert_next(string.format("(%u, %u, DATE_SUB(NOW(), INTERVAL %u SECOND))", 
	sb_rand(1, users_table_size), sb_rand(1, users_table_size * stream_scale), sb_rand(1, max_history_min) ))
   end

   db_bulk_insert_done()

--
-- Circles_Names table
-- 


   print("Creating table 'circles_names'")
   	query = [[
CREATE  TABLE IF NOT EXISTS `circles_names` (
  `circle_name_id` BIGINT UNSIGNED NOT NULL AUTO_INCREMENT ,
  `user_id` BIGINT UNSIGNED NOT NULL ,
  `circle_name` VARCHAR(255) NOT NULL ,
  `created` DATETIME NOT NULL ,
  PRIMARY KEY (`circle_name_id`) ,
  INDEX `fk_circles_users1` (`user_id` ASC) 
) ENGINE = ]] .. mysql_table_engine


   db_query(query)
   db_query("TRUNCATE TABLE circles_names")

   if dbweb_use_fk then
	query = [[
alter table follow add 
  CONSTRAINT `fk_circles_users1` FOREIGN KEY (`user_id` ) REFERENCES `users` (`user_id` )
]]

    db_query(query)

   end

   print("Inserting " .. users_table_size * circles_names_scale .. " records into 'circles_names'")

   db_bulk_insert_init("INSERT IGNORE INTO circles_names (user_id, circle_name, created) VALUES")


   for j = 1, users_table_size * circles_names_scale do

   c_val = sb_rand_str([[
@@@@@@@@@@@@@@@@@@@@@@-@ @@@@@@@@@@@@@@]])

    db_bulk_insert_next(string.format("(%u, '%s', DATE_SUB(NOW(), INTERVAL %u SECOND))", 
	sb_rand(1, users_table_size), c_val, sb_rand(1, max_history_min)))
   end

   db_bulk_insert_done()
   
--
-- Circles table
-- 


   print("Creating table 'circles'")
   	query = [[
CREATE  TABLE IF NOT EXISTS `circles` (
  `circle_id` BIGINT UNSIGNED NOT NULL AUTO_INCREMENT ,
  `circle_name_id` BIGINT UNSIGNED NOT NULL ,
  `user_id` BIGINT UNSIGNED NOT NULL ,
  `added_user_id` BIGINT UNSIGNED NOT NULL ,
  `added` DATETIME NOT NULL ,
  PRIMARY KEY (`circle_id`) ,
  INDEX `fk_circles_circles_names1` (`circle_name_id` ASC, `user_id` ASC) ,
  INDEX `userid` (`user_id` ASC) ,
  UNIQUE INDEX `unq_usadded` (`added_user_id` ASC, `circle_name_id` ASC) 
) ENGINE = ]] .. mysql_table_engine



   db_query(query)
   db_query("TRUNCATE TABLE circles")

   if dbweb_use_fk then
	query = [[
alter table follow add 
  CONSTRAINT `fk_circles_circles_names1`
    FOREIGN KEY (`circle_name_id` , `user_id` )
    REFERENCES `circles_names` (`circle_name_id` , `user_id` )
]]

--    db_query(query)


	query = [[
alter table follow add 
  CONSTRAINT `fk_circles_users3` FOREIGN KEY (`added_user_id` ) REFERENCES `users` (`user_id` )
]]

--    db_query(query)

   end


   print("Inserting " .. users_table_size * circles_scale .. " records into 'circles'")
   db_bulk_insert_init("INSERT IGNORE INTO circles  (circle_name_id, added_user_id,  added) VALUES")


   for j = 1, users_table_size * circles_scale do

    db_bulk_insert_next(string.format("(%u, %u, DATE_SUB(NOW(), INTERVAL %u SECOND))", 
	sb_rand(1, users_table_size * circles_names_scale), sb_rand(1, users_table_size), sb_rand(1, max_history_min)))
   end

   db_bulk_insert_done()

--
-- Comments table
-- 


   print("Creating table 'comments'")
   	query = [[
CREATE  TABLE IF NOT EXISTS `comments` (
  `comment_id` BIGINT UNSIGNED NOT NULL AUTO_INCREMENT ,
  `user_id` BIGINT UNSIGNED NOT NULL ,
  `stream_id` BIGINT UNSIGNED NOT NULL ,
  `message` TEXT NOT NULL ,
  `posted` DATETIME NOT NULL ,
  INDEX `fk_comments_users1` (`user_id` ASC) ,
  INDEX `fk_comments_wall1` (`stream_id` ASC) ,
  PRIMARY KEY (`comment_id`) 
 ) ENGINE = ]] .. mysql_table_engine

   db_query(query)
   db_query("TRUNCATE TABLE comments")

   if dbweb_use_fk then
	query = [[  alter table comments add 
  CONSTRAINT `fk_comments_users1` FOREIGN KEY (`user_id` ) REFERENCES `users` (`user_id` ) ]]

    db_query(query)

	query = [[  alter table comments add 
  CONSTRAINT `fk_comments_wall1` FOREIGN KEY (`stream_id` ) REFERENCES `stream` (`stream_id` ) ]]

    db_query(query)

   end

   print("Inserting " .. users_table_size * comments_scale .. " records into 'comments'")
   
   db_bulk_insert_init("INSERT IGNORE INTO comments (user_id, stream_id, message, posted) VALUES")


   for j = 1, users_table_size * comments_scale do

    db_bulk_insert_next(string.format("(%u, %u,'%s', DATE_SUB(NOW(), INTERVAL %u SECOND))", 
	sb_rand(1, users_table_size), sb_rand(1, users_table_size*stream_scale), 
        sb_rand_str("@@@@@@@ @@@ @@@@@@@@@@@"),
        sb_rand(1, max_history_min) ) )
   end

   db_bulk_insert_done()

   print("Updating circles with user_id")
   db_query("update circles set user_id = ( SELECT user_id FROM circles_names where circles_names.circle_name_id=circles.circle_name_id)")
   print("Updating stream with user_id")
   db_query("update stream set user_id = ( SELECT user_id FROM circles where circles.circle_id=shared_circle_id),  plusone_count = ( select count(*) from plusone where plusone.stream_id=stream.stream_id), comments_count = ( select count(*) from comments where comments.stream_id=stream.stream_id)")
   print("Updating stream with public circle")
--   db_query("update stream set shared_circle_id=1 where rand()<0.8")

end


function prepare()
   local query
   local i
   local j

   set_vars()

   db_connect()


   for i = 1,dbweb_databases_count do
     create_insert(i)
   end

   return 0
end

function cleanup()
   local i

   set_vars()

   for i = 1,dbweb_databases_count do
   print("Dropping database " .. i .. "'...")
   db_query("DROP DATABASE IF EXISTS sbtest".. i )
   end
end

function set_vars()
   dbweb_databases_count = dbweb_databases_count or 1
   users_table_size = users_table_size or 10000
   stream_scale = stream_scale or 10
   comments_scale = comments_scale or 30
   plusone_scale = plusone_scale or 10
   circles_scale = circles_scale or 100
   circles_names_scale = circles_names_scale or 10
   stream_plusone_factor = stream_plusone_factor or 100 -- how many times stream plus one = users_table_size / stream_plusone_factor
   max_history_min = max_history_min or 1000000 -- how many max minutes from now date walls or comments
   
   if (dbweb_use_fk == 'on') then
      dbweb_use_fk = true
   else
      dbweb_use_fk = false
   end

   if (dbweb_read_only == 'on') then
      dbweb_read_only = true
   else
      dbweb_read_only = false
   end

end
