pathtest = string.match(test, "(.*/)") or ""

dofile(pathtest .. "common.lua")

function thread_init(thread_id)
   set_vars()

   if (db_driver == "mysql" and mysql_table_engine == "myisam") then
      begin_query = "LOCK TABLES sbtest WRITE"
      commit_query = "UNLOCK TABLES"
   else
      begin_query = "BEGIN"
      commit_query = "COMMIT"
   end

end

function event(thread_id)
   local rs
   local userid
   local wallid
   local table_name
   local range_start
   local c_val
   local pad_val
   local query

   db_name = "sbtest".. sb_rand_uniform(1, dbweb_databases_count)
   db_query("USE "..db_name)

   userid = sb_rand(1, users_table_size)

   -- see what users I follow posted recently:

   rs = db_query("SELECT idwall,title,wall.posted,liked_count,comments_count  FROM wall JOIN follow ON (wall.iduser=follow.follow_iduser) WHERE follow.iduser=".. userid .." AND follow.approved=1 ORDER BY posted DESC LIMIT 10");

   -- post comment to one of these with some probability

   db_query(begin_query)

   wallid= sb_rand(1, users_table_size * wall_scale) -- TODO: later should be ID from returned result

   rs = db_query(string.format("INSERT IGNORE INTO comments (iduser, idwall, message, posted) VALUES (%u, %u,'%s', NOW() )",
        userid, sb_rand(1, users_table_size*wall_scale),
        sb_rand_str("@@@@@@@ @@@ @@@@@@@@@@@"))
        )

   rs = db_query("UPDATE wall SET comments_count=comments_count+1 WHERE idwall="..wallid)

   db_query(commit_query)

   -- delete one of old comments to keep balance
   
   db_query(begin_query)

   wallid= sb_rand(1, users_table_size * wall_scale) -- TODO: later should be ID from returned result
   rs = db_query("DELETE FROM comments WHERE idwall="..wallid.." ORDER BY posted ASC LIMIT 1")

   rs = db_query("UPDATE wall SET comments_count=comments_count-1 WHERE idwall="..wallid)
   db_query(commit_query)

   -- see what user I follow liked recently:
   rs = db_query("SELECT title, message, posted, liked_count,comments_count FROM wall JOIN ilike ON (ilike.idwall=wall.idwall) JOIN follow ON (ilike.iduser=follow.follow_iduser) WHERE follow.iduser=".. userid .." and approved=1 and visible=0 ORDER BY liked_date DESC LIMIT 10");

   db_query(begin_query)

   wallid= sb_rand(1, users_table_size * wall_scale) -- TODO: later should be ID from returned result

   rs = db_query("INSERT IGNORE INTO ilike (iduser,idwall,liked_date) VALUES ("..userid..","..wallid..", NOW())");
   rs = db_query("UPDATE wall SET liked_count=liked_count+1 WHERE idwall="..wallid);

   db_query(commit_query)

   -- delete one ilike to keep balance
   db_query(begin_query)

   rs = db_query("DELETE FROM ilike WHERE idwall="..wallid.." ORDER BY liked_date ASC LIMIT 1")
   rs = db_query("UPDATE wall SET liked_count=liked_count-1 WHERE idwall="..wallid);

   db_query(commit_query)

   -- read comments to my wall
   
   rs = db_query("SELECT wall.title, wall.message, comments.message, users.username, comments.posted  FROM comments JOIN wall ON (wall.idwall=comments.idwall) JOIN users ON (users.iduser=comments.iduser) WHERE wall.iduser="..userid.." ORDER BY comments.posted DESC LIMIT 10")

   -- add someone as friend - ideally should be ID based on comments
   rs = db_query("INSERT IGNORE INTO follow (iduser, follow_iduser, created) VALUES " ..
              string.format("(%u, %u, NOW())", 
	      userid, sb_rand(1, users_table_size) ))

   -- delete someone from follow  - to keep balance
   rs = db_query("DELETE FROM follow WHERE iduser="..userid.." ORDER BY created ASC limit 1")

end

